service.playSoundScroll()
require "import"
import "android.content.Intent"
import "android.speech.RecognizerIntent"
import "android.net.Uri"
import "android.provider.ContactsContract"
import "android.os.Vibrator"
import "android.os.Handler"
import "android.speech.tts.TextToSpeech"

tts = TextToSpeech(activity, nil)
handler = Handler()
apelAnulat = false

function vibrate(duration)
  vibrator = activity.getSystemService(activity.VIBRATOR_SERVICE)
  vibrator.vibrate(duration)
end

function startVoiceRecognition()
  vibrate(200)
  intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
  intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
  intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, "ro-RO")
  intent.putExtra(RecognizerIntent.EXTRA_PROMPT,"Spune numele persoanei pe care vrei să o apelezi pe WhatsApp")
  activity.startActivityForResult(intent,1)
end

function getWhatsAppContactId(name)
  local uri = Uri.parse("content://com.android.contacts/data")
  local cursor = activity.getContentResolver().query(uri,nil,
    "display_name LIKE ? AND mimetype=?",
    {"%"..name.."%","vnd.android.cursor.item/vnd.com.whatsapp.voip.call"},nil)
  if cursor and cursor.moveToFirst() then
    local id=cursor.getString(cursor.getColumnIndex("_id"))
    cursor.close()
    return id
  else
    cursor.close()
    return nil
  end
end

function apelWhatsApp(contactId,contactName)
  intent=Intent(Intent.ACTION_VIEW)
  intent.setDataAndType(Uri.parse("content://com.android.contacts/data/"..contactId),
  "vnd.android.cursor.item/vnd.com.whatsapp.voip.call")
  intent.setPackage("com.whatsapp")
  activity.startActivity(intent)
  vibrate(200)
end

function callWhatsAppContact(contactName)
  local contactId=getWhatsAppContactId(contactName)
  if contactId then
    tts.speak("Voi apela contactul "..contactName.." în 4 secunde.",TextToSpeech.QUEUE_FLUSH,nil)
    vibrate(200)
    countdown=3
    runnable=luajava.createProxy("java.lang.Runnable",{
      run=function()
        if apelAnulat then
          tts.speak("Apel anulat.",TextToSpeech.QUEUE_FLUSH,nil)
          apelAnulat=false
          return
        end
        if countdown>0 then
          tts.speak(tostring(countdown),TextToSpeech.QUEUE_FLUSH,nil)
          countdown=countdown-1
          handler.postDelayed(runnable,1000)
        else
          apelWhatsApp(contactId,contactName)
        end
      end
    })
    handler.postDelayed(runnable,3000) -- 3 secunde să rostească numele
  else
    tts.speak("Nu am găsit contactul "..contactName.." în WhatsApp.",TextToSpeech.QUEUE_FLUSH,nil)
  end
end

function onActivityResult(requestCode,resultCode,data)
  if requestCode==1 and resultCode==-1 then
    results=data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS)
    if results and results.size()>0 then
      contactName=results.get(0)
      apelAnulat=false
      callWhatsAppContact(contactName)
    else
      tts.speak("Nu am înțeles numele contactului.",TextToSpeech.QUEUE_FLUSH,nil)
    end
  end
end

function onKeyDown(keyCode,event)
  if keyCode==4 then -- Butonul back
    apelAnulat=true
    tts.speak("Apel anulat.",TextToSpeech.QUEUE_FLUSH,nil)
    return true
  end
end

startVoiceRecognition()